/*

--> TCS3200 Sensor que reconoce el colores.

Los TCS3200 son sensores que convierten en frecuencia la intensidad de luz medida por una matriz de fotodiodos.
La frecuencia entregada por el sensor TCS3200 es mayor cuanta mayor luminosidad se detecte.

-->  Los pines de conexión del sensor a Arduino se muestran en los comentarios

  Sensor         Arduino
-----------      --------
 VCC               5V
 GND               GND
 s0                8 // Entrada de selección de la escala de frecuencia de salida
 s1                9 // Entrada de selección de la escala de frecuencia de salida
 s2                10 // Entrada de selección del tipo de fotodiodo
 s3                11 // Entrada de selección del tipo de fotodiodo
 OUT               12
 
*/

//Pines del sensor que van conectado a arduino
const int s0 = 8;  
const int s1 = 9;
const int s2 = 10;  
const int s3 = 11;  
const int out = 12;   

/* La palabra clave const significa constante. Es un calificador variable que modifica el comportamiento de la variable, 
haciendo que sea una variable de "sólo lectura". Esto significa que la variable se puede utilizar como cualquier otra 
variable de este tipo, pero su valor no se puede cambiar.  */

// Pines del led que van conectado a arduino
int redLed = 3;  //izq
int greenLed = 6;  //segundo de la derecha
int blueLed = 5; //primero de la derecha

// Variables  
int red = 0;  
int green = 0;  
int blue = 0; 
    
void setup()   
{  
  Serial.begin(9600); 
  pinMode(s0, OUTPUT);  
  pinMode(s1, OUTPUT);  
  pinMode(s2, OUTPUT);  
  pinMode(s3, OUTPUT);  
  pinMode(out, INPUT);  
  
  pinMode(redLed, OUTPUT);  
  pinMode(greenLed, OUTPUT);  
  pinMode(blueLed, OUTPUT);  
  
  digitalWrite(s0, HIGH);  // La escala de frecuencia de salida está S0 y S1 en high los dos, que sería al 100%.
  digitalWrite(s1, HIGH);  
}  
    
void loop() 
{  
  color(); 
  Serial.print(" Intensidad Rojo: ");  
  Serial.print(red, DEC);  
  Serial.print(" Intensidad Verde: ");  
  Serial.print(green, DEC);  
  Serial.print(" Intensidad Azul: ");  
  Serial.print(blue, DEC);  
  //Serial.println();  

// ----------------- Apagado ----------------- //
  if (red == 47 || red == 49 || red == 50 || red == 42 || red == 48 && green == 47 || green == 52 || green == 53 || green == 54 && blue == 43 || blue == 44 || blue == 42)
  {  
   Serial.println(" - (Apagado)");  
   digitalWrite(redLed, LOW); // OFF 
   digitalWrite(greenLed, LOW);  // OFF
   digitalWrite(blueLed, LOW);  // OFF
  }

// ----------------- ROJO ----------------- //
  else if (red == 11 || red == 12 && green == 35 || green == 36 || green == 37 || green == 30 && blue == 27 || blue == 26 || blue == 28)
  {  
   Serial.println(" - (Rojo)");  
   digitalWrite(redLed, HIGH); // Led rojo ON 
   digitalWrite(greenLed, LOW);  
   digitalWrite(blueLed, LOW);  
  }    

  // ----------------- Verde ----------------- //

  else if (red == 15 || red == 16 && green == 12 || green == 11 && blue == 16 || blue == 15)   
  {  
   Serial.println(" - (Verde)");  
   digitalWrite(redLed, LOW);  
   digitalWrite(greenLed, HIGH);  // Led verde ON
   digitalWrite(blueLed, LOW);   
  }  

  // ----------------- Azul ----------------- //

    else if (red == 25 || red == 27 || red == 26 && green == 27 || green == 28 && blue == 18 || blue == 17 || blue == 12)   
  {  
   Serial.println(" - (Azul)");  
   digitalWrite(redLed, LOW);  
   digitalWrite(greenLed, LOW);  
   digitalWrite(blueLed, HIGH); // Led azul ON  
  }  

  /* // ----------------- Amarillo ----------------- //

    else if (red == 5 || red == 6 && green == 9 && blue == 14 || blue == 15)
  {  
   Serial.println(" - (Amarillo)");  
   digitalWrite(redLed, 255); // Led rojo ON 
   digitalWrite(greenLed, 54);  // Led verde ON
   digitalWrite(blueLed, LOW);  
  } */

       // ----------------- Azul Cielo ----------------- //

      else if (red == 19 || red == 20 && green == 11 || green == 12 && blue == 8)
  {
   Serial.println(" - (Azul cielo)");  
   digitalWrite(redLed, 0); // Led rojo OFF 
   digitalWrite(greenLed, 191);  // Led verde ON
   digitalWrite(blueLed, 255); // Led azul ON
  }
  
   // ----------------- Rosa ----------------- //

      else if (red == 5 || red == 6 && green == 10 || green == 11 && blue == 7 || blue == 8 || blue == 9)
  {  
   Serial.println(" - (ROSA)");  
   digitalWrite(redLed, 255); // Led rojo ON 
   digitalWrite(greenLed, 0);  
   digitalWrite(blueLed, 128);  // Led azul ON
  }

  else {
  Serial.println();   
  }
  delay(300);   
 digitalWrite(redLed, LOW);  
 digitalWrite(greenLed, LOW);  
 digitalWrite(blueLed, LOW);  
 }  


/* Para seleccionar el color que se lee de los fotodiodos, se utilizan los pines de control S2 y S3.
Dado que los fotodiodos están conectados en paralelo, estableciendo S2 y S3 en diferentes combinaciones 
de LOW y HIGH permite seleccionar diferentes grupos de fotodiodos. */

void color()  
{    
  digitalWrite(s2, LOW);  // Al poner los dos en low seleccionamos el rojo
  digitalWrite(s3, LOW);  
  //count OUT, pRed, RED  
  red = pulseIn(out, digitalRead(out) == HIGH ? LOW : HIGH);  // Leyendo la frecuencia de salida del sensor
  digitalWrite(s3, HIGH);  // Al poner s3 en high se pone el azul
  //count OUT, pBLUE, BLUE  
  blue = pulseIn(out, digitalRead(out) == HIGH ? LOW : HIGH);  // Leyendo la frecuencia de salida del sensor
  digitalWrite(s2, HIGH);  // Al poner s2 en high se pone el verde
  //count OUT, pGreen, GREEN  
  green = pulseIn(out, digitalRead(out) == HIGH ? LOW : HIGH);  // Leyendo la frecuencia de salida del sensor
}
